#!/usr/bin/perl

use strict;
use warnings;

# If Perl can't load any of these, you won't see any print statements.  Instead, you'll see something like
#
# Can't locate FrogUtils/utility.pm in @INC (@INC contains: C:\wbin\pbin\Perl5Lib
# C:/Perl64/site/lib C:/Perl64/lib .) at D:\home\frog\bin\TestPerl.pl line 12.
# BEGIN failed--compilation aborted at D:\home\frog\bin\TestPerl.pl line 12.
#
# Depending on how your Perl is set up.  It means that you need to set your PERL5LIB
# environment variable to point to whereever you put the perl5lib/FrogUtils files.
# Hint: the PERL5LIB value should end with "perl5lib"; it should NOT end with
# 'FrogUtils'

print "Tests to see if your Perl has all the stuff that is needed to run MarkdownWrapper.pl\n\n";

#print "Loading the 'FrogUtils::utility' package\n";
#print " (FrogUtils::utility loads 'Date::Calc qw( Add_Delta_DHMS )')\n";
use FrogUtils::utility;		# Frogymandias utility subs.
#print "Loading the 'FrogUtils::MarkdownW' package\n";
use FrogUtils::MarkdownW;	# Markdown.pl 1.01 converted to be a real package.
#print "Loading the 'FrogUtils::SmartyPantsW' package\n";
use FrogUtils::SmartyPantsW;	# SmartyPants.pl 1.51 converted to be a real package.
#print "Loading the 'Text::Wrap' package\n";
use Text::Wrap;
#print "Loading the 'File::Path' package\n";
use File::Path;	
#print "Loading the 'Digest::MD5 qw(md5_hex)' package\n";
use Digest::MD5 qw(md5_hex);
#print "Good. they all loaded.\n\n";

my $s = "";
$s .= "[Lorem ipsum dolor](http://lipsum.com/) sit amet, *consectetur adipiscing elit*. Aliquam semper condimentum urna ";
$s .= "vitae consequat. Nulla facilisi. Nam mattis mi ut pellentesque eleifend. Proin mollis metus ";
$s .= "molestie risus **rhoncus laoreet**.\n\nProin in lobortis orci, `sed auctor dogfood sapien`. Curabitur ";
$s .= "luctus velit nec eros condimentum euismod ac quis nisl. Proin nec quam eu nisi pulvinar";
$s .= "dapibus quis eget elit.";
my $Text = $s;

print "Here is some text formatted as Markdown:\n\n";
print "$Text\n\n";

my $Wrapped = wrapit($Text, 79);
print "Here it is after running hard word wrapping\n\n";
print "$Wrapped\n\n";

my $Marked = Markdown($Text); 		# Markdown() is in FrogUtils::MarkdownW
my $HTML = SmartyPants($Marked);	# SmartyPants() is in FrogUtils::SmartyPantsW
print "Here it is after running through Markdown()\n\n";
print $HTML;

print "\nWriting the HTML as 'lorem.html'\n";
writefile_byref("lorem.html", \$HTML);	# writefile_byref() is in FrogUtils::utility.pm
print "Writing the wordwrapped text as 'lorem-wrapped.txt'\n";
writefile_byref("lorem-wrapped.txt", \$Wrapped);
print "Writing the unwrapped text as 'lorem-unwrapped.txt'\n";
writefile_byref("lorem-unwrapped.txt", \$Text);

exit 0;

# Word wrap a string.
sub wrapit {
	my $comments = shift;
	my $NumCols = shift;
	if ( ! defined $NumCols ) { $NumCols = "79"; }
	if (defined $comments) {
		my $delim = "\n";
		
		$comments = $comments . $delim;
		my @pars = split (/$delim/, $comments);
		my ($s, $s1, $par);
		# Loop through pars, collect them all in $s.
		$s = "";
		foreach $par (@pars) {
			#$par = trim($par);
			$Text::Wrap::columns=$NumCols;
			$Text::Wrap::separator="\n";
			$par = wrap("","",$par);
			#print "OnePar: |$par|\n";
			$s .= $par . $delim;
		}
	$s =~ s/\n+$//s;	# Remove trailing '\n's
	return $s . "";
	} else {
		return "";
	}
}

