
### Start of Variables ###

# Variables that start with "_" are template variables
# If found, the leading "_" will be removed.
# They are used to match "%%Variable%% template variables in 
# template pieces in the configuration files.

# _PageTitle is used in the Page Header template.
# i.e. <html><head><title>%%PageTitle%%</title>  etc.
_PageTitle = Setting up a Windows machine

# _PageID isn't used yet.  But it will be--make sure that every page has a unique _PageID.
_PageID = setting_up_windows

# Force all images to be created? 
# (Usually only needed when you are fiddling with image sizes.)
# Or if you are experimenting with ImageMagickConfig in the config files
ForceImageCreation = 0

# Put assorted config variables as comments at the start of the output file.
# Probably should only be used while debugging.
Debug = 0

# Also generate a word wrapped version of this file?
# Only is needed if you want to make this file available on the site.
MakeTextFile = 1

File = GetFrogdown.bat.txt

### End of Variables ###

%id shortversion nl%
###Short version

%b%2022-04-12%/b%

* Create `C:\home` 
* Download [Frogdown.zip](Frogdown.zip) and unzip it in `C:\home`  It will unzip into `C:\home\Frogdown`
<!-- * Download and install [ActiveState Perl](http://www.activestate.com/activeperl).  Makes sure that Perl is on the path.  -->
* Download and install %l Strawberry Perl|https://strawberryperl.com/% You may need to %l install Perl modules|FrogdownInstall.html#installing-perl-modules%
* Download and install [ImageMagick](http://www.imagemagick.org/script/index.php)  Make sure that `convert.exe` is on the path (`magick.exe` for newer versions of ImageMagick.)
* Add `C:\home\Frogdown\bin` (Frogdown scripts) and%br%
`C:\home\Frogdown\WindowsOnly\bin` (UnxUtils programs) to the path .
* Add `FHOME=C:\home` and `PERL5LIB=C:\home\Frogdown\bin\perl5lib` environment variables.
* Copy site specfic files from `C:\home\Frogdown\etc\markcms-windows` to `C:\home\Frogdown\etc\markcms`  Maybe look at them.
* Navigate to `C:\home\Frogdown\WindowsOnly\bin` and run (in this order)%br%
`AreunxutilsProgramsHere.bat`%br%
`DisplayEnvironmentVariables.bat`%br%
`IsImageMagickHere.bat`%br%
`IsPerlHere.bat`%br%
`TestPerl.pl` (And checks that required Perl modules are installed.)%br%
<!-- `ShortFrogdownDemo.bat`%br% -->
Check that none of them complain.  If so, then fix any problems that are reported.  Maybe skim the rest of the page.
* Optional.  %l Install a web server, such as Apache2|PiRef.html#install-apache-php%
* Look over the [Intro to Frogdown](DogFood.html)
<!-- * Check out [Making it GUI](MakingItGUI.html) (Still is uncorrected 2013 version) -->

%#% %b%End of 2022-04-12 corrections.  The rest of this page has a lot of wrong paths that need changing as per above.%/b% %/#%

%id longversion nl%
###Long version 

We go into a bit more detail.  In case the above was too cryptic.

%%NameLinks%%

%#%
###Opening a DOS command prompt (easy)

Relax, you'll only need to do this a few times.  The rest is point-and-click.

(Windows 7, and earlier) Click %button%Start%/button%, type `cmd.exe` in the search box and press %button%Enter%/button%.  An MS-DOS command prompt window should open.  Voil.  But keep reading.

I use ActiveState Perl so all my directions are about this version of Perl.  If you use some other version of Perl, than adapt as needed.
%/#%

%id gettingthefiles%
###Getting the files

%#%
%imagebox img=screens/frogtemp-1.gif|ib=rimagebox|mwp=80|c=Temporary directory where<br>you unzipped Frogdown.zip%

%b%Download the zip file to a temporary directory%/b% Create a directory (say, `C:\FrogTemp`) and download [Frogdown.zip](Frogdown.zip) (%attr Frogdown.zip%) to it.  In Windows Explorer, navigate to `C:\FrogTemp` and unzip `Frogdown.zip`  
%/#%

%b%Create the 'home' directory%/b%  We use Linux/UNIX conventions and use a `home` directory.  To increase the odds of this working right off the bat, create `C:\home`.  The rest of these docs will assume that this is what we are using.

Download %l Frogdown.zip|http://www.frogymandias.org/Frogdown/Frogdown.zip% (%attr Frogdown.zip%) into `C:\home` and unzip it.  It should unzip to `C:\home\Frogdown`

%l FrogdownScripts.zip|FrogdownScripts.zip% (%attr FrogdownScripts.zip%) is just the scripts and supporting files without all the Frogdown .md files and image files, in case you already have all the rest and just want the latest version of the Frogdown scripts.

%sidebar  sb=bqsidebar|t=The lazy way to install%
Here %l is a .bat file|GetFrogdown.bat.txt% that will do the downloading and unzipping *if* you already have the required UnxUtils programs on your path.  Save it as `GetFrogdown.bat` and put it in `C:\home`

(After you have the UnxUtils programs installed) you can use to download updates after you have Frogdown configured and running.  (This is what I use myself to test that everthing is working: I already have all the supporting programs installed and configured so `GetFrogdown.bat` works.  I run the `.bat` file and it downloads the .zip file, unzips it, and copies the configuration files.  Frogdown is 100% operational after a few seconds.
%/sidebar%

%##%
%b%Copy the files to where they belong%/b%  Open two Windows Explorer windows.  Have one in `C:\FrogTemp`, the other in `C:\home`
%#%%imagebox img=screens/frogtemp-2.gif|ib=rimagebox|mwp=80|c=Your C:\home directory after copying%%/#%
%imagebox img=screens/wininstalltests-1.gif|ib=rimagebox|mwp=80|c=C:\home\WindowsOnly\InstallTests%

%b%Copy Windows only files%/b% (This zip file is also for UNIX/Linux and contains several files that are only applicable for Windows PCs)  In the `FrogTemp` folder, change to `WindowsOnly\bin`  In the `C:\home` folder, change to the `bin` folder.  You should see several files with `.pl` file extensions.  Now copy the `.exe` files from the `FrogTemp` window to the `c:\home\bin` folder.

Now change to the `C:\home` folder and then to `WindowsOnly\InstallTests`.  It should look like the bottom %b%InstallTests%/b% screenshot. But don't click on anything.  Yet.

%clearfloats%
%/##%

%id installingperl%
###Installing Perl

%b%2022-04-13%/b% I switched to %l Strawberry Perl|https://strawberryperl.com/%. 

To install CPAN modules in Strawberry Perl

	c:
	cd \Strawberry\perl\bin
	cpan File::Path
	cpan Digest::MD5
	cpan Date::Calc

(*Don't* install CPAN modules until `TestPerl.pl` complains that they are missing!  Wait until we get to the "More validity checks" section.) Installing CPAN modules will take a while with lots of stuff scrolling on the screen.  Go get a cup of coffee while the CPAN module installation is happening.

Or you can use ActiveStatePerl [from here](http://www.activestate.com/activeperl). I used to use ActiveState Perl until I was updating the Frogdown documentation and installing Frogdown on my laptop.  I was befuddled when I tried to install CPAN modules into ActiveState Perl.  I uninstalled ActiveState Perl and installed Strawberry Perl and was able to install CPAN modules into Strawberry Perl.  YMMV.


%##%
Click the %button%Download Now%/button% button.  You undoubtedly want the "Free Community Edition."  Choose the version that is most appropriate for your machine.  (64 bit, etc.)  Download it and double click on the file you downloaded.  It is a standard Windows setup program so you can mostly click through the defaults.  The only one to watch out for is to make sure that it adds Perl to your path.

After it is installed, switch to your `InstallTests` folder and click on `IsPerlHere.bat`  You should see something like

	Tests to see if Perl is installed at all.
	...
	This is perl 5, version 14, subversion 2 (v5.14.2) built for MSWin32-x64-multi-thread
	(with 1 registered patch, see perl -V for more detail)

	Copyright 1987-2011, Larry Wall

	Binary build 1402 [295342] provided by ActiveState http://www.ActiveState.com
	Built Oct  7 2011 15:19:36
		Press any key to continue . . .
	
(My Perl is several years old.)  If you see something like

	'perl' is not recognized as an internal or external command,
	operable program or batch file.
	Press any key to continue . . .

This means that Perl isn't installed.  Try uninstalling it and reinstalling it and make sure to watch out for questions about putting Perl on the path.  It really needs to be on the path.


%#%then this is *probably* all you need to do.  If you have problems with missing modules you will need to use the `ppm` program to install any missing modules.  But let's not worry about this for now.%/#%
%/##%

%id imagemagick%
###Installing ImageMagick

MarkdownWrapper.pl uses [ImageMagick](http://www.imagemagick.org/script/index.php) to resize images.  Download ImageMagick [from here](http://www.imagemagick.org/script/binary-releases.php#windows) and follow the instructions.  switch to your `C:\home\Frogdown\WindowsOnly\InstallTests` folder and click on `IsImageMagickHere.bat`  You should see something like

	Tests to see if ImageMagick is installed at all.
	...
	Version: ImageMagick 6.7.7-2 2012-05-25 Q16 http://www.imagemagick.org
	Copyright: Copyright (C) 1999-2012 ImageMagick Studio LLC
	Features: OpenMP

	Press any key to continue . . .

If so, then ImageMagick is installed and is on the path.  If not...try Uninstalling and reinstalling and looking out for any questions about putting ImageMagick on the path.

%id unxutils%
###You need some UnxUtils programs

You need some of the programs from UnxUtils, which is a collection of common UNIX (and Linux) command line programs.  MarkdownWrapper.pl uses some of these and assumes that they exist and are on your path.  Frogdown.zip includes the UnxUtils programs we need, in the%br%
`C:\home\Frogdown\WindowsOnly\bin` directory.  The next section tells how to add this to your path (so you don't need to download then entire UnxUtils suite). 

If you want the entire UnxUtils suite of programs, %l download and unzip UnxUtils.zip|https://sourceforge.net/projects/unxutils/%, copy the individual programs to a convenient directory and then add this directory to your path.

%id cbin%
###Adding `C:\home\Frogdown\bin` to your path

%b%2022-04-13%/b% These docs were originaly written for Windows 7.  The dialog boxes for later versions of Windows are different but the objective is the same: to edit the environment variables.

%clearfloats%
%imagebox img=screens/win-env-vars-3.gif|ib=rimagebox|mwp=80|c=Editing the PATH Environment Variable%

This can be a detour if you have never done this.  To be on the safe side, let's make a backup copy of your environment variables.  Switch to the `C:\home\Frogdown\WindowsOnly\InstallTests` folder and click on `GetEnvironmentVariables.bat`  It will open two windows.  A DOS windows that says

	echo off
	Displaying them in Notepad.
	You need to close Notepad to exit this.

And Notepad with a copy of your environment variables.  %b%Save As%/b% them with a filename like `OriginalEnvironmentVariables.txt`  But otherwise keep Notepad open while you do the next steps.

%b%Editing your environment variables%/b%  (Windows 7) From Windows Control Panel, click "System and Security", "System", and then "Advanced system settings"  (May need administrative privileges?)   The "System Properties" dialog should open up.  Click on the "Advanced" tab, if needed.  Then click on the %button%Environment Variables%/button% button.

You want the bottom "System variables" window.  Scroll down so the "Path" variable is highlighted.  Then click on %button%Edit...%/button%.

When the "Edit..." dialog first opens, the entire path is highlighted.  %warning%Danger!%/warning%  While it is highlighted, typing any character ***will overwrite the entire path***.  If this happens, click on %button%Cancel%/button% immediatly. 


The safer method is to press your right-arrow key to 1., de-select the selection and 2., move the curser to the end of the path.  At this point you type a semicolon (';'), followed by the directory you want to add to the path.  In the example shown, the end of the existing path is

    C:\Program Files (x86)\GPSBabel
	
If you wanted to add `C:\home\Frogdown\bin` to the end of the path, you would type `;C:\home\Frogdown\bin` right after `GPSBabel`  Like

	C:\Program Files (x86)\GPSBabel;C:\home\Frogdown\bin
	
Move around the edit box with your left and right arrows and verify that the change you made is what you wanted it to be.  Examine the `PATH` variable in the `servars.txt` file to make sure that what you have edited corresponds to what the PATH variable contents are.

Also add the UnxUtils directory (that comes with Frogdown)%br%`C:\home\Frogdown\WindowsOnly\bin` to the path.

%#%
When you are sure you have it correct, click on %button%OK%/button%  And %button%OK%/button% again to get out of the "Environment variables" box.  %button%OK%/button% again to get out of the "System Properties" box.  
%/#%

%clearfloats%

%id perl5lib%
###Creating the `PERL5LIB` environment variable

%imagebox img=screens/win-env-vars-4.gif|ib=rimagebox|mwp=80|c=Creating the PERL5LIB Environment Variable%

This is similar to "Adding a directory to your path."  Same thing, except for when you get to the "System variables" window, click on the %button%New...%/button% button.

Enter `PERL5LIB` for "Variable name:".  Enter the path to where you put the perl5lib files.  The default is%br%
`C:\home\Frogdown\bin\perl5lib`

Then %button%OK%/button% your way out.


%b%Checking%/b% Switch to the %b%InstallTests%/b% folder and click on `DisplayEnvironmentVariables.bat`  This will display your Environment variables in a DOS window using `more`.  Press the space bar to advance by screenfulls. Check to see if

	FHOME=C:\home
	PERL5LIB=C:\home\Frogdown\bin\perl5lib

 are there.  And that `C:\home\Frogdown\bin` is at the end of the PATH variable.

 
%#% Use the same procedure for checking.  Start a new MS-DOS window.  Type

	set | more
	
and page through and see if the `PERL5LIB` variable is there.  Double check to see that the `unxutils` directory was added to the end of the path.  If so, you can do a quick test by doing

	set | less
	
'less' is one of the `unxutils` programs.  It is just like `more`, except it is better.  You can scroll backwards and forwards.

&lt;snark&gt;Microsoft copied piping (the '|' operation), the 'more' command, directory trees, and a few other things from UNIX, but they didn't get to `less`.&lt;/snark&gt;
%/#%

%clearfloats%

%id sitespecfic%
### Editing the configuration files

Almost done.  Go to the `etc` directory.  You will see four directories:  `markcms` is where the configuration files go.  `markcms-linux`, `markcms-linux-raspberry-pi` and `markcms-windows` contain files that are specfic to each platform.  You, of course, want `markcms-windows`.  So change to `markcms-windows`.  Copy the contents of `markcms-windows` to `markcms`.  Change to `C:\home\Frogdown\etc\markcms`.

%#%
Open `frog-site-locations.cfg`.  The variables of interest are

	# Locations that don't change (are the same for normal, mobile, and tablet sites.)

	# Can be used in a navbar
	# Windows (not using a web server)
	_FullSite = file:///C:/home/Frogdown/frog_html/index.html

These variables are used in places like navigation bars.  To have links that go to the three variations.  The above example is set up assuming that you aren't using any kind of server to develop on.  You will be just double clicking on the .html files in Explorer and they will open in your browser.  If you are using a server, then use the appropriate URLs (not file locations.)

You probably don't need to change this, so just copy it to the `markcms` directory.  Now open `frog-site.cfg`. The important variables are like:
%/#%

Open `frog-site.cfg` and look at

	BaseInDir = C:\home\Frogdown\frog_authoring
	BaseOutDir = C:\home\Frogdown\frog_html

`BaseInDir` is where the .md files are that you edit.  `BaseOutDir` is where the html files are to be written.  ` Again, these probably don't need to be changed

The reason why these site specfic configuration files weren't in `markcms` in the first place is so that they won't be overwritten when you load a new version of Frogdown (by downloading and unzipping Frogdown.zip.)  The only way that the site-specfic configuration files get into `markcms` is when you copy them yourself.  Frogdown.zip is for both Windows and Linux and having different versions of the configuration files keeps us all sane.
	
%clearfloats%

%id morechecks%
###More validity checks.

In an Explorer windows change to `C:\home\Frogdown\WindowsOnly\InstallTests`  Double click on `TestPerl.bat`, which will do a several sanity checks.  If all goes well you will see

	TestPerl.pl  1.02  2022-04-11
	Tests to see if you are set up to process Frogscript with MarkdownWrapper.pl

	This is good:
	  Module 'FrogUtils::utility' is loaded.
	  Module 'FrogUtils::MarkdownW.pm' is loaded.
	  Module 'FrogUtils::SmartyPantsW' is loaded.
	  Module 'File::Path' is loaded.
	  Module 'Digest::MD5' is loaded.
	  Module 'Date::Calc' is loaded.

	  Your FHOME directory is 'C:/home/Frogdown/'
	  Your configuration directory (C:/home/Frogdown/etc/markcms/) exists.
	  'frog.cfg' exists in your configuration directory.
	  'frog-site.cfg' exists in your configuration directory.

	Testing for several unxutil programs we need...
	Good.  3 out of 3 unxutils programs were found.

	Testing to see if ImageMagick is installed
	Good! ImageMagick (magick) is installed

If so, then good.  If it complained about anything recheck the above steps.  If `TestPerl.bat` completed OK you can go on to the next step.

%##%
%b%ShortDemo%/b% Double click on `ShortDemo.bat`.  A DOS windows will display

	C:\home\WindowsOnly\InstallTests>echo off
	Demonstration of the Frogscript system
	Notepad has loaded 'ShortDemoOutput.txt'
	You must close Notepad to end this.

Notepad is displaying the output of `ShortDemo.pl` (that is in `c:\home\bin`)  It will explain what it did.  At this point, you are good to go.
<!-- so make it easy to use by doing a few more things to [make it real GUI](MakingItGUI.html). -->
 %/##%
 
%id drag-and-drop%
###Drag-and-drop to process .md files

There are two batch files in the `Frogdown` directory that are designed to process .md files with drag-and-drop:

%clearfloats%
%imagebox img=screens/drag-and-drop-arrow.png|ib=limagebox|mwp=55|c=Drag-and-drop index.md to DragOntoOne.bat|fic=0%

%#% %imagebox img=screens/index_md-dropped.jpg|ib=limagebox|mwp=90|c=After processing|fic=0% %/#%

`DragOntoDebug.bat`  For debugging. It will process the .md file with the debug option (that shows a lot of configuration variables but doesn't generate any .html files.)

`DragOntoDoOne.bat` For normal processing.  When you ae done editing a .md file and have saved it, drag the .md file onto `DragOntoDoOne.bat`.  For example, to process `index.md` to create `index.html`:

%clearfloats%

You should see

	Drag-and-drop an .md file onto this.
	Runs MarkdownWrapper.pl on C:\home\Frogdown\frog_authoring\Frogdown\index.md (no debug)

	MarkdownWrapper 0.45  2022-04-11
	Read config file C:/home/Frogdown/etc/markcms/frog.cfg
	Read config file C:/home/Frogdown/etc/markcms/frog-site.cfg
	Read config file C:/home/Frogdown/etc/markcms/frog-site-locations.cfg
	Read input file: 'index.md'
	Testing to see if ImageMagick is installed
	Good! ImageMagick (magick) is installed
	Substitutions = 'D\:\/home|c:/home' 'D\:\/home' will be replaced by 'c:/home'
	Worklog:
	Converted CSS template vars and wrote 'C:/home/Frogdown/frog_html/Frogdown/frog.css'
	Created text file: C:/home/Frogdown/frog_html/Frogdown/index.text
	Included file 'Frogymanheader.inc'
	Created text file: C:/home/Frogdown/frog_html/Frogdown/Frogymanheader.inc
	Created HTML file: C:/home/Frogdown/frog_html/Frogdown/index.html

Navigate to `C:/home/Frogdown/frog_html/Frogdown/index.html` and double click on `index.html`  It should open in your browser.  If it does, then cool.  Now go back to `C:\home\Frogdown\frog_authoring\Frogdown` and double click on `DoAllFrogs.bat`  This will generate `GenAll.bat`. 

	echo off
	Rem Windows batch file to run MarkdownWrapper.pl
	Rem (Perl says that we are 'MSWin32'
	Rem Generated by DoAllFrogs.pl 1.02 2013-07-09
	Rem Running MarkdownWrapper.pl

	MarkdownWrapper.pl "copy-sd-cards.md" "frog"
	MarkdownWrapper.pl "DogFood.md" "frog"
	MarkdownWrapper.pl "FrogdownInstall.md" "frog"
	MarkdownWrapper.pl "FrogdownWindows.md" "frog"
	MarkdownWrapper.pl "FrogPi.md" "frog"
	MarkdownWrapper.pl "FrogPiShort.md" "frog"
	MarkdownWrapper.pl "FrogSteps.md" "frog"
	MarkdownWrapper.pl "index.md" "frog"
	MarkdownWrapper.pl "MakingItGUI.md" "frog"
	MarkdownWrapper.pl "PiRef.md" "frog"
	pause

Double click on `GenAll.bat`  It will create all the rest of the Frogdown .html files.

%id copypaste%
###Write using the copy-paste method.

Study the .md files for a while. Then start creating your own files by copying-and-pasting relevant portions from the existing .md file (usually the header stuff at the beginning of  .md file.)  For tricky things like sidebars and imageboxes, copy-and-paste examples from existing .md files that do what you want.  Change as needed.  (I still use this method.)

Skim through %l Introduction to Frogdown|dogfood.html%. 

%id notepadpp%
###Use Notepad++ to edit

I use %l Notepad++|http://notepad-plus-plus.org/% to edit Perl and .md files.  It is handy for writing Perl because it color codes Perl syntax.  It also inserts itself on the right-click menu you get when you right-click a file.  So you can right-click a .md file (or any other type of file) and open it with Notepad++.  This is a termendous advantage because it makes Perl programs have a (sort of) GUI interface.

%clearfloats%

%##%
%imagebox img=screens/notepad++.gif|ib=limagebox|mwp=95|c=Editing with Notepad++%
%/##%

%imagebox img=screens/notepadpp.png|ib=limagebox|mwp=83|c=Editing with Notepad++|fic=1%
%clearfloats%

%##%
It even color codes .md files, to a certain extent.

%clearfloats%
%imagebox img=screens/notepadpp-02.jpg|ib=limagebox|mwp=85|c=Editing this file with Notepad++|fic=1%
%/##%