### Start of Variables ###

## Version that lives in Frogdown directory

# Variables that start with "_" are template variables
# If found, the leading "_" will be removed.
# They are used to match "%%Variable%% template variables in 
# template pieces in the configuration files.

# _PageTitle is used in the Page Header template.
# i.e. <html><head><title>%%PageTitle%%</title>  etc.
_PageTitle = What's new with Frogdown

# _PageID isn't used yet.  But it will be--make sure that every page has a unique _PageID.
_PageID = Frogdown_whats_new

# Force all images to be created? 
# (Usually only needed when you are fiddling with image sizes.)
# Or if you are experimenting with ImageMagickConfig in the config files
ForceImageCreation = 0

# Put assorted config variables as comments at the start of the output file.
# Probably should only be used while debugging.
Debug = 0

# Also generate a word wrapped version of this file?
# Only is needed if you want to make this file available on the site.
# MakeTextFile = 0

# If using any php code...
#HTMLFileExt = .php

### End of Variables ###

### Start of Span Variables ###
# User definable <span> tags.

# Must escape '=' as '\=' 

_Erin = <span style\="color: green; font-weight:bold;">

### End of Span Variables ###

%#%
%imagebox img=images/frog-logo.jpg|ib=rimagebox|mwp=25|c=Frogymandias<br>Look on my works...%
%/#%

(This page last modified on %attr WhatsNew.md|dt%)

%b%4/27/2022%/b% Added a new section on %l installing Debian 11 on a cheap refurb|OtherLinux.html%.  Because PC refurbs + SSD are currently cheaper than Raspberry Pis.

%b%4/26/2022%/b%  Added hints for installing Frogdown on %l a Debian Jessie machine|FrogdownInstall.html#installdebian%.

Added additional "specs" field to `\%attr` tag.  Without the tag, `\%attr` *{filename}*`\%` returns the timestamp and size of the file.  The specs attribute can be any of "DTS", where "D" returns only the date, "DT" returns the date and times, and "DTS returns date, time, and file size"  Specs defaults to "dts".  

Hence "This page last modified on `\%attr WhatsNew.md|dt\%"` returns "This page last modified on %attr WhatsNew.md|dt%"  (Don't need the file size for this use.)

%b%4/24/2022%/b% Introduced a new `\%save\%` tag to protect blocks of text that absolutely should not be processed by Frogdown/Markdown.  Such as embedded PHP code.  Example: 

	\%save\%
	</php>
	
		print "<p>This line was printed by PHP</p>\n";
		
	?>
	\%/save\%

<!-- 
Without \%save\% tags, we'd get (after running through `Frog/Markdown`):
	
</php>

	print "<p>This line was printed by PHP</p>\n";
	
?>	
-->
	
%#%Of course, you need to use `.php` as a file extension for pages that include PHP code (unless your server is explictly configured to treat `.html` pages as `.php` pages.%/#%  Here is an example  of a page with embedded PHP code: %l SomePHP.php|SomePHP.php%:

Without the `\%save\%` tag, embedded PHP code would be treated by Frogdown/Markdown as any other HTMLish code and would get a lot of added `<p>`, `\%code\%`, etc. tags added to all the PHP code.  Now you can use Frogdown with embedded `.php` code.  You will also need to use the new

	# If using any php code...
	HTMLFileExt = .php
	
configuration variable in the configuration section of Frogdown pages that have embedded PHP code so that the file that Frogdown writes will have a `.php` file extension, instead of the normal `.html` file extension.  (Web servers generally won't process any PHP code unless the file extension is `.php`)  See the `.md` file for `SomePHP.php`: %l SomePHP.text|SomePHP.text%.

You can also use `\%save\%` tags to sidestep any bugs you find in Frog/Markdown processing.  Write what you want in straight HTML and surround it with `\%save\%` tags.  And report the bug to %mailto info@frogymandias.org|I found a bug in Frogdown.%


%b%4/22/2022%/b%  Added support for time zone override.  In case the machine that is hosting your site uses a different time zone than you want to display (when using the `\%attr ...` tag, for example.)  To use this, create a new `TZOFFSET.txt` file to your `$basein` (`DocumentRoot`) directory that has the amount of time zone correction you need.  Example:

	03:00
	(EST) 

will change all timestamps referrenced by `\%attr` type functions.  (The 2nd line isn't currently used, but it is intended to be the time zone you are converting to.  In the above example, 3 hours will be added to the system's local time(stamps) to make it (them) be EST) If you don't need to change timestamp references, then you don't need to create TXOFFSET.txt. (This depends on if your machine uses your local time, somebody else's local time, or UTC time.)

Also moved this "What's New" page to the Frogdown directory because it is mostly about Frogdown updates.  I'll eventually modify the old What's New file so it describes the Frogymandias site as a whole and not just Frogdown.

%b%4/21/2022%/b% Added logic to Markdown.pl so it won't copy files that are identical (source and destination).  Previously it would copy files regardless.  Which took a lot of time for files (like Frogdown.zip) that are largish and are referenced on multiple pages. If you used `GenAll.sh` a lot.

Added new `\%attr ` *filename*`\%` tag that works like `\%attr Frogdown.zip` %attr Frogdown.zip%.  It displays some of the attributes of a file. (This was easy because most of the logic was created for the 'won't copy files that are identical' code.  If the attributes for two files are identical then the files are identical and don't need to be copied.)  

Because Frogdown generates pure .html, the `attr` data is generated when you run Frogdown on a page.  The `attr` data won't update if you later change the file that is being referenced (until you regenerate the `.md` page.)

Also %l started a section on using PHP|PiRef.html#php%  This isn't really applicable to Frogdown right now (because Frogdown doesn't use PHP), but I wanted to get this started because I eventually want to start using PHP for a few things. (4/26/2022 See above 4/24/2022 entry for `.php` code examples.)  As long as we have all %l installed Apache2 and PHP|PiRef.html#install-apache-php%.  (But I'm now adding stuff to Frogdown (`\%attr \%` tag) that I was planning on doing with PHP. Oh, well.)

Updated (Windows) %l GetFrogdown.bat.txt|GetFrogdown.bat.txt% and (Linux) %l GetFrogdown.sh.txt|GetFrogdown.sh.txt% to also copy `Frogdown.zip` %attr% into the authoring page, so the new `\%attr \%` code will work when you generate Frogdown pages.

%b%4/15/2022%/b% Made changes to documentation and to `Markdown.pl` and `DoAllFrogs.pl` (As I was updating documentation I saw the need to make some enhancements to the scripts.)  Suggest that you at least download (to `~` or to `C:home`, depending on what you identify as) and unzip %l FrogdownScripts.zip|FrogdownScripts.zip%

%b%4/14/2022%/b% Removed some print statements from `MarkdownWrapper.pl` that were for debugging but otherwise cluttered up the screen.  And updated documentation.

%b%4/13/2022%/b% Made a *lot* more changes to the %l Frogdown|index.html% pages to make the installation process be easier.  

`MarkdownWrapper.pl` (and `TestPerl.pl`) now test for the existance of ImageMagick.  They didn't before and I discovered a potentially dangerous situation for some systems if `convert` was called and ImageMagick wasn't installed.  ImageMagick's conversion program used to be called `convert`.  But ImageMagick also discovered problems with systems that used `convert` for other purposes.  So current versions of ImageMagick now use `magick` for their conversion program.  We now test for all three cases.

Added new `\%##\%` and `\%\##\%` tags that will totally delete (in the .html file) anything between them.  Because of the problem of trying to comment out blocks of text that already have comments.  (Comments don't nest in HTML!)  I commented out a lot of text that wasn't needed and/or needed extensive rewriting and found that I needed this tag.

Deprecated making the wordwrapped `.text` files be wordwrapped.  Because modern browsers now wordwrap text (not HTML) files (rather than letting long lines extend off the right side).  So if you download any individual `.text` file, they won't be wordwrapped (in the future--I would need to reprocess all the pages on the site.)  There is now a variable in `MarkdownWrapper.pl` so you can enable/disable word wrapping.  For instance, %l WhatsNew.text|WhatsNew.text% isn't wordwrapped anymore.

Added a `Substitutions` configuration variable.  Use like

	Substitutions = frog|spring
	
Would replace all instances of 'frog' with 'spring'.  It can be handy for quick temporary modifications.

%b%4/1/2022%/b% Made a lot of changes to %l Frogdown|index.html%  Specfically, added a lot on how to install Frogdown on a RaspBerry Pi (including how to configure a brand new RaspBerry Pi)

%b%3/27/2022%/b% Added `Substitutions` as a 
%l configuration variable|FrogdownInstall.html#configfiles% (so you can change any sensitive information that is in your .html file if you use the `debug = 1` configuration option.  Like your real login name.)

%b%3/25/2022%/b% Got Frogdown working on GoDaddy cPanel.  Also updated the %l Frogdown install instructions|FrogdownInstall.html% with some %l cPanelish information|FrogdownInstall.html#godaddy% about configuring for GoDaddy.  

%l Dogfood|DogFood.html%.  It took longer than it should for me to install Frogdown on my GoDaddy server (The GoDaddy cPanel upgrade didn't copy over anything having to do with Frogdown so I had to install Frogdown from scratch.)  I maybe need to rethink the Linux install documentation.  (The Windows install documentation is fine.)

%b%12/6/2018%/b% Started long overdue revamp to %l responsive design|https://en.wikipedia.org/wiki/Responsive_web_design%.  i.e., so the same design works on both desktop and mobile, which is still a work in progress.  Meaning that the look and feel is a bit rough.  But it works on a cell phone now.  Now Google's persnickety %l Is your web page mobile-friendly?|https://search.google.com/test/mobile-friendly% page doesn't complain.  Copy-and-paste %tt%http://www.frogymandias.org/%/tt% into the search box.

Yeah!  %warning%Arm-pump%/warning%.

And got rid of the old separate .mobile and .tablet versions.  Which didn't work that well anyway.  

%b%12/5/2018%/b% Did some much needed editing of the home page. To get closer to making the concept be as sharp as the vision.

%b%12/4/2018%/b% Remembered that I forgot to update this page!  I have been working in the %l Color Gamuts|gamuts/index.html% section.  Mainly in the %l 3D Color Gamuts|gamuts/gamuts-2018-xd3-html/index.html% section.  (Changing obsolete .vrml 3D models (that require an obscure plugin) to be XD3DOM (that should work in any browser with no plugin.))

%b%2/29/2016%/b% Added new page describing how to %l make a camera scanning adapter with a 3D printer|../3-d/index.html%.  

Um, Frogdown hasn't gotten any updates because I've been using it right along to add other pages (look at the home page closely) and it works quite well as it is.

%b%3/21/2014%/b% Added support for `dirconfig.cfg` which is a configuration file that affects the current directory only.  Anything defined in this overrides the normal configuration files.  Reason: I wanted to override the footers in some directories.

%b%3/17/2014%/b%  %erin%Happy St. Patricks day.%/erin%  Added new '`flc`' and '`fa`' tags to %l imagebox|DogFood.html#imagebox%.  And added

	MakeTheseJPEGs = png|tif|tiff

variable to config files.   To solve headaches I discovered when %l writing new documentation|http://www.frogymandias.org/imagery/index.html%.

Made '\_' handling in file names be more robust.  (There should not be any problems with using any combination of '\_' characters in file names.  You have watch out when using '\_' characters in normal text though, because Markdown will use the '\_' character to as the delimiters for italics.  '\_' is the 'start-of-italics delimiter and '\_' is the end-of-italics delimiter.  (`MarkdownWrapper.pl` calls Markdown in the middle of processing, which is what made handling '\_' characters in filenames be so much fun.))

%b%11/15/2013%/b% Blew off the mothballs and added a %l mailto|DogFood.html#mailto% tag.  And added a filter to the %l links|DogFood.html#inlinelinks% code so that `_` underscore characters in URLs won't cause problems.  As I said before, this is tricky, but we'll see how the new filter works.

%b%7/9/2013%/b% Changed `\%table\%` and `\verse\%` so they support Markdown markup.  Found that image file filenames with a leading underscore ('_') character cause problems, so (for now) they will not be processed.  (Markdown's handling of underscores is one of its most criticized aspects and I haven't figured out a workaround yet.)

Which reminded me to tweak `DoAllFrogs.pl` so that it will also reject `.md` files that start with a '_'  Because `.md` files that start with an '_' are only for debugging from the command prompt.

Removed sections of this page that are now incorporated in the documentation proper.  I added a link to the documentation, and struck out a portion of the omitted text.  (And added `\%s\%`%s%text to be struck out%/s%`\%/s\%` tags for strikeout to MarkdownWrapper.pl)

%b%7/8/2013%/b% Worked on error checking some more.  You can enter `Debug` as either the 2nd or 3rd parameter (the 2nd parameter is normally the config file and you need to be able to debug what a config file does.)  And reworked error messages so they are hopefully more illuminating.  

Added HTML 'name' and 'ID' attributes.  With an %l automated named links generator|DogFood.html|(The list of links at the top of the file was just added.)%.  See %l Links to internal names|DogFood.html#namelinks|Which \*should\* go directly to the description of 'Links to internal names'%  (Currently this does not work on the mobile (i.e., jQuery Mobile) sites.)

Added more options to a lot of what is described on the %l Intro to Frogdown|DogFood.html|mostly to the 'dogfood' and 'Installing Frogdown' pages% page.  And worked on the Frogdown documentation.  The `.csst` files were modified to support new features so they need to be updated.  The old ones aren't compatible.

Redid the %l `\%verse\%` tag to have options|DogFood.html#verse|And redid the internal structure so it generates 100\% HTML.  So it is hopefullly more robust.  And extensible.%.  

%#%The main thing is that `BaseInDir` and `BaseOutDir` need to be accurate in the config files.  If they aren't, then there will be a whole bunch of issues.  Some of which I trap as fatal errors.%/#%

%b%7/6/2013%/b% Made error checking code be more robust.  If you enter `Debug` as the 2nd parameter (normally is the configuration file), it will display some configuration information and then stop without doing any further processing (which was the function of the deprecated '`_MakeMeSmile.md`' file.)  Will also trap more fatal errors, display the errors and then stop.  Instead of the previous behavior of proceding blithely on processing even though there were fatal errors.

%b%7/5/2013%/b%  Renamed 'FrogDown' to 'Frogdown' to match Markdown.  Linux casedness being what it is, you probably should delete your frog*_html directories and regenerate everything from your .md files.  And take a close look at how your `.md` files are named.  Run `DoAllFrogs.sh` and `GenAll.sh` in both your authoring and `Frogdown` (yes, this is renamed also) directories.  Camel case is its own reward.

Added %l user definable `<span>` tags|DogFood.html#udspan%.   %s%Add a section like...%/s%
	
%b%7/2/2013%/b% Added additional font declaration template variables to `frog.csst`.

	_BodyBackgroundColor = #eee
	_BodyFontFamily = Calibrixx, Verdanaxx, Arial, "Helvetica Neue", Helvetica, sans-serif
	_BodyFontColor = Black
	_HeadingFontFamily = Cambria, Arial, "Helvetica Neue", Helvetica, sans-serif
	_PreBackgroundColor = #fffaf4
	_CodeFontFamily = Consolasxx, "Lucida Console", "Courier New", Courier, "Andale Mono", Monaco, Monospace
	_CodeFontFamilyx = Georgia, Garamond, Palatino, "Times New Roman", Times, serif
	_CodeFontSize = 12px

and corresponding `\%%CodeFontFamily\%%` (etc.) variables in the rest of the `.csst` file.  To make it easy to experiment with changing fonts.  Pay real close attention to the %l Table of fonts installed on each operating system|http://www.apaddedcell.com/web-fonts|Only use these fonts!  You can't use a font that isn't installed on the user's system.%  If you know of a better such list then please let us know at <info@frogymandias.org>.

You should also change the style sheet declaration in your .cfg files to use this notation:

%#% Umm, there is a bug with escaping '%' characters with backslashs; in that it doesn't work sometimes. %/#%
\ \ \ \ %tt%&lt;link  REL="StyleSheet" TYPE="text/css" HREF="%b%&#37;%_PathToHome&#37;%%/b%frog.css" media="all"&gt;%/tt%

so your HTML will always use the `.css` file that is in your `DocumentRoot`  So you don't have to have a different `.csst` file for every directory you use.

%sidebar  sb=bqsidebar|t=About _PathToHome%
%tt%&#37;%\_PathToHome&#37;%%/tt% is a template variable that is filled with `MarkdownWrapper.pl`  It contains the relative path to your home directory.  So if your HTML file is in the home directory then %tt%&#37;%\_PathToHome&#37;%%/tt% will equal `./`.  But if your HTML file was two levels up (`Programmers/Unix_Programmers/DennisRichie.html`), it would be `../../`.
%/sidebar%

Various internal changes to `MarkdownWrapper.pl` to hopefully make it more robust.  (But I noticed when writing the preceding paragraphs that I still have some issues with escaping the '%' character.  Noted.)

Various changes to `%l Frogdown.zip|Frogdown.zip|Zip file that has everything you need%` so that it is hopefully less confusing.
	
%b%7/1/2013%/b% Added %l non-break space|DogFood.html#nbsp%.  Preface any space character with a backslash (\) to make it non-breaking.

Added new %l `\%verse\%` block tag|DogFood.html#verse%.  %s%That acts like HTML `<pre>`, except that it doesn't change...%/s%

Added support for %l inline links, inline images, and tables|DogFood.html%.  %s%Will eventually add them to the documentation proper.%/s% %#%For now, look at the %l Punching\ Bag\ page|PunchingBag.html|The page for testing out new code %%/#%


%b%6/27/2013%/b% Added %l `DoAllFrogs.pl` script|FrogdownInstall.html#doallfrogs% that generates a `GenAll.bat` batch (Windows) or `GenAll.sh` shell (Linux) script that will run MarkdownWrapper.pl on all .md files in the directory.

Added a new template for tablets.  Right now it is nothing earthshaking.  I just copied the mobile configuration file and changed `MaxImageWidth = 300` to `MaxImageWidth = 700` so the images will be generated larger. <http://tablet.frogymandias.org>  But it is a start.  If you use `DoAllFrogs.pl`, then invoke it like

	DoAllFrogs.pl frog frog-mobile frog-tablet
	
to get a `GenAll` script that will generate all the HTML files.  (Don't forget that you need to manually copy the `themes` directory for the new `frog_tablet` directory so that Mobile jQuery will work right.  Still need to fix this so Markdownwrapper.pl can copy more than single files.

(Link to original 6/27/2013  %l What's New|WhatsOld.html% page.)

Comments?  Write to %mailto info@frogymandias.org|Is all this really so new?%

