
### Start of Variables ###

# Variables that start with "_" are template variables
# If found, the leading "_" will be removed.
# They are used to match "%%Variable%% template variables in 
# template pieces in the configuration files.

# _PageTitle is used in the Page Header template.
# i.e. <html><head><title>%%PageTitle%%</title>  etc.
_PageTitle = Backing up your Raspberry Pi system disk to another SD card

# _PageID isn't used yet.  But it will be--make sure that every page has a unique _PageID.
_PageID = Clone-SD

# If using any php code...
#HTMLFileExt = .php

# Force all images to be created? 
# (Usually only needed when you are fiddling with image sizes.)
# Or if you are experimenting with ImageMagickConfig in the config files
ForceImageCreation = 0

# Put assorted config variables as HTML comments at the start of the output file.
# Probably should only be used while debugging.  (Ctrl-U in browser)
Debug = 0

#Substitutions = frog|spring

# Also generate a word wrapped version of this file?
# Only is needed if you want to make this file available on the site.
MakeTextFile = 1

### End of Variables ###

###To copy (backup) the disk you are running on to a better micro-SD card:

Put a %l high endurance|https://www.bhphotovideo.com/c/product/1547790-REG/sandisk_sdsqqvr_032g_an6ia_max_endurance_microsd_32gb.html% micro-SD card (that is at least as large as the one you are now using) into a %l micro-SD card reader|https://www.bhphotovideo.com/c/product/1431026-REG/sandisk_sddr_b531_an6nn_mobilemate_usb_3_0_card.html%.  Plug it into a USB port on your Raspberry Pi. Type `lsusb`.  It should display something like 

	Bus 002 Device 003: ID 0781:cfcb SanDisk Corp. SDDR-B531
	Bus 002 Device 001: ID 1d6b:0003 Linux Foundation 3.0 root hub
	Bus 001 Device 009: ID 1a2c:2124 China Resource Semico Co., Ltd Keyboard
	Bus 001 Device 008: ID 046d:c52b Logitech, Inc. Unifying Receiver
	Bus 001 Device 007: ID 1a40:0101 Terminus Technology Inc. Hub
	Bus 001 Device 003: ID 051d:0002 American Power Conversion Uninterruptible Power Supply
	Bus 001 Device 002: ID 2109:3431 VIA Labs, Inc. Hub
	Bus 001 Device 001: ID 1d6b:0002 Linux Foundation 2.0 root hub

`SanDisk Corp. SDDR-B531` is the micro-SD card reader.  

Then

	startx  (If you aren't already in the GUI)

	Accessories/SD Card Copier

(If you don't see "SD Card Copier" then you need a %l newer version of the Raspberry Pi OS|https://www.raspberrypi.com/software/%.) Copy From Device" should be something like `SH32G" (dev/mmcblk0)` (This is your boot disk that you want to clone to a blank card.)

"Copy To Device" should be `SanDisk SDDR-B531` Or whatever reader showed up when you did '`lsusb`'.

%clearfloats%
%imagebox img=screens/clone-disk-to-sd-1.jpg|ib=limagebox|mwp=50|c=Will clone your boot SD to the blank SD that is in your card reader|fic=0%
%clearfloats%

Then click on the "Start" button

%imagebox img=screens/sd-card-to-sd-card-3.jpg|ib=limagebox|mwp=50|c=Now it is doing the copy|fic=0%
%clearfloats%

Wait until it is done.  After it is done you can test the SD by powering down and swapping the newly created disk with your Pi's boot disk.  Then power up.  It should boot like it always did.  You *might* be able to use the new boot SD in a different model Pi.  This has worked in all the Pi I have (Zero W, 3B, 3B+, and 4B) but isn't guarenteed to work.

###To copy one Pi boot SD to a different SD

To be safe use a full size reader and put the micro-SD you want to clone in an adapter and %b%slide the write-protect switch to "lock"%/b% so you *can't* copy a blank SD onto your source SD. Put the SD card adapter in the reader.    Put the (blank?)  destination micro-SD in a different model reader (so you can tell them apart!)  Plug the reader that has the source SD in (use the USB3 ports if a Pi 4 (or greater)).  Type `lsusb` and note the name of the reader.  Now plug in the reader that has the blank SD.  Do `lsusb again and note the name of the 2nd reader that holds the blank SD.

	startx  (if needed)

	Accessories/SD Card Copier

Make *sure* that you are straight on "Copy From Device" (source card) and "Copy To Device" (unformatted blank SD card).  (Putting the source disk in a write-protected SD adapter *should* protect you from overwriting the source SD.  But still...

%clearfloats%
%imagebox img=screens/sd-card-to-sd-card-1.jpg|ib=limagebox|mwp=50|c=Will clone from one SD to the blank SD that is in your 2nd card reader|fic=0%
%clearfloats%

Is what I see when I clone from my SanDisk SDDR-C531 full size SD reader to my micro-SD Sandisk SDDR-B531 reader.

Then press "Start".  It will take at least a few minutes to do the copy (faster if you use USB3 ports.)

