### Start of Variables ###

# Variables that start with "_" are template variables
# If found, the leading "_" will be removed.
# They are used to match "%%Variable%% template variables in template pieces
_PageTitle = Frogdown Markup Language
_PageID = Frogdown-index

# Generate images even if they already exist?  Usually only when playing with resizing.
ForceImageCreation = 0

# Shows assorted config variables as HTML comments in the output HTML file.  If 1 
Debug = 0
ShowVars = 0

### End of Variables ###

### Start of Span Variables ###
# (Are normally defined in the .cfg file.  Define them here as a temporary override.)
# 'Span variables' means defining your own character level formatting tags
# Usage:  Watch out for %warning%scaremongering%/warning%

_Warning = <span style\="color: Red; font-weight:bold;">
# </span>

### End of Span Variables ###
<!--  Now we are in the <body>  -->

%#% Start of included file %/#%
%%Include Frogymanheader.inc%%
%#% End of included file %/#%

This page last modified on %attr index.md|dt%

%b%Frogdown%/b% is a markup language that is a superset of %l Markdown|https://daringfireball.net/projects/markdown/%. The entire Frogymandias site was written in FrogDown.  A markup language is an alternative to a full blown CMS%#%(Content Management System)%/#%, such as WordPress.  The advantage of creating a site in a markup language is that the site can be nothing but straight HTML, which eliminates most security concerns. No web interface means a very tiny attack vector.

I develop Frogymandias on a Windows machine %#%and run the script that generates the HTML files%/#% so I can refine and debug the easy way with multiple windows.  When I'm ready to publish I copy the source files to the Linux server that hosts Frogymandias and run the appropriate script to generate the HTML (and images) on the Linux server.  I find that this is a very productive way to generate a web site.  Writing in Frogdown is easier than writing in HTML directly, because modern HTML is very verbose and isn't really suited for direct composition.  Frogdown brings back the simplicity of writing in old school HTML (before HTML got all fancy.)

Here is an example of some of the Frogdown code for some of the first paragraph of this page:

>%tt%###Create Web sites with Frogdown markup language%br%
%br%
\%b\%Frogdown\%/b\% is a markup language that is a superset of 
\%l Markdown|https://daringfireball.net/projects/markdown/\%. The entire Frogymandias site was 
written in FrogDown.  A markup language is an alternative to a full blown CMS%#%(Content Management System)%/#%, such as WordPress.%/tt%

I get a lot of mileage from seeing working examples of something that is close to what I want and then adapting it to exactly what I want. %l index.text|index.text% is the source code for this page.  (The same pattern works for almost all of the other pages.)  Find a page on this site that contains examples of what you want to format and look at the .text file to see how it is formatted in Frogdown.

%#% We *really* need Frogdown code to handle <ul>%/#%
<ul class="NameLinks">
	<li class="NameLinksLi">See the %l Introduction to FrogDown|DogFood.html% for more about how it works.  The Frogdown syntax with lots of examples to copy-and-paste.
	<li class="NameLinksLi">%l How to get a Raspberry Pi running from scratch|FrogPi.html% (and install Frogdown)
	<ul>
		<li class="NameLinksLi">%l Tips on configuring a Raspberry Pi|PiRef.html%
		<li class="NameLinksLi">%l Tips on installing Debian 11 (Bullseye) |OtherLinux.html% Say, on a cheap refurb because Raspberry Pis are so expensive now.
	</ul>
	<li class="NameLinksLi">%l Installing Frogdown|FrogdownInstall.html% (Linux + Windows) Some general information. (Mostly updated for 2022.)
	<li class="NameLinksLi">%l Setting up a Windows Machine for Frogdown|FrogdownWindows.html% (Windows installation step-by-step)  (Partially updated for 2022.)%br%
	<li class="NameLinksLi">%l What's New with Frogdown|WhatsNew.html%
</ul>

<!--
Right now this is a really bad bug. (Ctrl-U...)

<p>The instructions, below, haven't been updated in a long time and might not (probably don't) match the current version of Frogdown.  Refer to the above Raspberry Pi documentation to clear up any discrepancies.  When I get the Raspberry Pi version as good as it can be, I'll update the other documentation to match.</p>

The above paragraph should not be '48bc263b598b91c8aaa20e48b9ea6130' (which looks to be a Markdown character encoding that never got decoded.)

It is still a really bad bug. (Ctrl-U...) The list item, below, should not be 'f6274fc3a2e121063919f53b3abc1e22' 'f6274fc3a2e121063919f53b3abc1e22' is a Markdown encoding that never got decoded. 
<li>%l Making it Gui|MakingItGUI.html% tells you how to run Windows Frogdown without using the MS/DOS prompt
<ul class="NameLinks">
<li class="NameLinksLi">%l Making it Gui|MakingItGUI.html% tells you how to run Windows Frogdown without using the MS/DOS prompt.
</ul>

Still trying to suss out this encoding debacle.  It seems to have something to do with HTML block tags (left angle 'P' right angle; left angle 'li class="NameLinks"' right angle, etc.
-->
